!disablestatusbar = $1F48|!addr

main:
	LDA $010B|!addr
	CMP #$C7
	BNE +
	LDA $010C|!addr
	BNE +
	RTL
	+
	LDA !disablestatusbar
	BEQ +
	RTL
	+
	LDA $13D4|!addr
	BEQ +
	RTL
	+
	%invoke_sa1(sa1main)
	RTL


!maxtile_get_slot            = $0084B0

sa1main:
	STZ $0E
	LDA #$04
	STA $0F
	LDA $0F31|!addr
	BEQ +
	INC $0F
	INC $0F
	LDA #$03
	STA $0E
	BRA ++
	+
	LDA $0F32|!addr
	BEQ ++
	INC $0F
	LDA #$02
	STA $0E
	++
	LDA $0DBF|!addr
	CMP #10
	BCC +
	INC $0F
	LDA $0E
	ORA #$04
	STA $0E
	+
	
	LDA $0DC2|!addr
	BEQ +
	LDA $0F
	CLC
	ADC #12
	STA $0F
	LDA $0E
	ORA #$08
	STA $0E
	+
	
	LDY $0F
	LDA $0E
	PHA
	REP #$30
	LDA #$0000
	JSL !maxtile_get_slot
	BCS +
	SEP #$30
	PLA
	RTL
	+
		
	SEP #$20
	REP #$10
	LDX $3100
	LDA #$04
	STA $0F
	
	
	;clock
	LDA #$CE
	STA $400000,x
	INX
	LDA #$10
	STA $400000,x
	INX
	LDA #$23
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	
	;ones
	LDA #$E8
	STA $400000,x
	INX
	LDA #$10
	STA $400000,x
	INX
	LDA #$22
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	
	PLA
	STA $0E
	AND #$02
	BEQ +
	;tens
	LDA #$E0
	STA $400000,x
	INX
	LDA #$10
	STA $400000,x
	INX
	LDA #$21
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	INC $0F
	+
	
	LDA $0E
	AND #$01
	BEQ +
	;hundreds
	LDA #$D8
	STA $400000,x
	INX
	LDA #$10
	STA $400000,x
	INX
	LDA #$20
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	INC $0F
	+
	
	;coin
	LDA #$CE
	STA $400000,x
	INX
	LDA #$1A
	STA $400000,x
	INX
	LDA #$33
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	
	LDA $0E
	AND #$04
	BEQ +
	;tens
	LDA #$E0
	STA $400000,x
	INX
	LDA #$1A
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	INC $0F
	+
	
	;ones
	LDA #$E8
	STA $400000,x
	INX
	LDA #$1A
	STA $400000,x
	INX
	LDA #$31
	STA $400000,x
	INX
	LDA #$30
	STA $400000,x
	INX
	
	
	LDA $0E
	AND #$08
	BEQ +
	PHB
	PHK
	PLB
	LDY #$000B
	-
	LDA itemboxx,y
	STA $400000,x
	INX
	LDA itemboxy,y
	STA $400000,x
	INX
	LDA itemboxtiles,y
	STA $400000,x
	INX
	LDA itemboxprops,y
	STA $400000,x
	INX
	INC $0F
	DEY
	BPL -
	PLB
	+
	
	
	REP #$20
	LDA $0F
	AND #$00FF
	TAY
	SEP #$20
	LDX $3102
	-
	LDA #$00
	STA $400000,x
	INX
	DEY
	BPL -
	
	RTL
	
itemboxx:
	db $70,$78,$80,$88
	db $88,$88
	db $70,$78,$80,$88
	db $70,$70

itemboxy:
	db $07,$07,$07,$07
	db $0F,$17
	db $1F,$1F,$1F,$1F
	db $17,$0F

itemboxtiles:
	db $0A,$0B,$0B,$0A
	db $1A,$1A
	db $0A,$0B,$0B,$0A
	db $1A,$1A

itemboxprops:
	db $36,$36,$36,$76
	db $76,$76
	db $B6,$F6,$F6,$F6
	db $36,$36

!timehundredsvram = $6200
!timetensvram = $6210
!timeonesvram = $6220
!cointensvram = $6300
!coinonesvram = $6310

nmi:
	LDA $010B|!addr
	CMP #$C7
	BNE +
	LDA $010C|!addr
	BNE +
	RTL
	+
	LDA !disablestatusbar
	BEQ +
	RTL
	+
	LDA #$80
	STA $2115
	LDA $0DBF|!addr
	JSL $00974C|!bank
	REP #$20
	PHA
	CPX #10
	BEQ +
;coin tens
	LDA.w #!cointensvram
	STA $2116
	LDA #$1801
	STA $4300
	TXA
	AND #$000F
	ASL #5
	CLC
	ADC.w #digits
	STA $4302
	LDY.b #digits>>16
	STY $4304
	LDA #$0020
	STA $4305
	LDX #$01
	STX $420B
	+
;coin ones
	LDA #!coinonesvram
	STA $2116
	LDA #$1801
	STA $4300
	PLA
	AND #$000F
	ASL #5
	CLC
	ADC.w #digits
	STA $4302
	LDY.b #digits>>16
	STY $4304
	LDA #$0020
	STA $4305
	LDX #$01
	STX $420B
	
	
	LDA $0F31|!addr
	BEQ +
;timer hundreds
	LDA #!timehundredsvram
	STA $2116
	LDA #$1801
	STA $4300
	LDA $0F31|!addr
	AND #$000F
	ASL #5
	CLC
	ADC.w #digits
	STA $4302
	LDY.b #digits>>16
	STY $4304
	LDA #$0020
	STA $4305
	LDX #$01
	STX $420B
	BRA ++
	+
	LDA $0F32|!addr
	BEQ +
	++
;timer tens
	LDA #!timetensvram
	STA $2116
	LDA #$1801
	STA $4300
	LDA $0F32|!addr
	AND #$000F
	ASL #5
	CLC
	ADC.w #digits
	STA $4302
	LDY.b #digits>>16
	STY $4304
	LDA #$0020
	STA $4305
	LDX #$01
	STX $420B
	+
;timer ones
	LDA #!timeonesvram
	STA $2116
	LDA #$1801
	STA $4300
	LDA $0F33|!addr
	AND #$000F
	ASL #5
	CLC
	ADC.w #digits
	STA $4302
	LDY.b #digits>>16
	STY $4304
	LDA #$0020
	STA $4305
	LDX #$01
	STX $420B
	+
	
	
	SEP #$20
	
	RTL


digits:
incbin "digits.bin"